unit fScriptInfo;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, ExtCtrls, TypInfo, atScript;

type
  TfmScriptInfo = class(TForm)
    TreeView1: TTreeView;
    pnScriptInfo: TPanel;
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
     procedure ShowInformation( AScript:TatPascalScripter );
  end;

var
  fmScriptInfo: TfmScriptInfo;

implementation

{$R *.DFM}

procedure TfmScriptInfo.FormKeyPress(Sender: TObject; var Key: Char);
begin
   if word(key)=VK_ESCAPE then
   begin
      key:=#0;
      Close;
   end;
end;

procedure TfmScriptInfo.FormShow(Sender: TObject);
begin
   with TreeView1 do
      if Items.Count>0 then
         Selected:=Items[0];
end;

procedure TfmScriptInfo.ShowInformation( AScript:TatPascalScripter );
var c,c1             : integer;
    node,node1,node2 : TTreeNode;
    row,col          : integer;
    aux              : string;
begin
   { constructs a script information tree }
   with AScript.ScriptInfo, TreeView1 do
   begin
      Items.Clear;
      Items.BeginUpDate;
      { Routines }
      node:=Items.Add(nil,'Routines');
      for c:=0 to Routines.Count-1 do
         with Routines[c] do
         begin
            AScript.GetRowColFromSource(DeclarationSourcePos,row,col);
            node1:=Items.AddChild(node,Format('''%s'' - declared on source line %d',[Name,row]));
            node2:=Items.AddChild(node1,'Variables');
            for c1:=0 to Variables.Count-1 do
            begin
               AScript.GetRowColFromSource(Variables[c1].DeclarationSourcePos,row,col);
               Items.AddChild(node2,Format('''%s'' (%d reads) - declared on source line %d',[Variables[c1].name,Variables[c1].ReadCount,row]));
            end;
         end;
      { Classes }
      node:=Items.Add(nil,'Known classes');
      for c:=0 to AScript.Classes.Count-1 do
         with AScript.Classes[c] do
         begin 
            node1:=Items.AddChild(node,Format('''%s'' - descending from ''%s''',[Name,AncestorName]));
            node2:=Items.AddChild(node1,'Properties');
            for c1:=0 to Properties.Count-1 do
               with Properties[c1] do
               begin
                  if Assigned(Properties[c1].Getter) then
                     if Assigned(Properties[c1].Setter) then
                        aux:='read and write'
                     else
                        aux:='read only'
                  else
                     if Assigned(Properties[c1].Setter) then
                        aux:='write only'
                     else
                        aux:='unusable';
                  Items.AddChild(node2,Format('''%s'': %s (%s)',[
                     Properties[c1].Name,
                     GetEnumName(TypeInfo(TatPascalTypeKind),ord(Properties[c1].DataType)),
                     aux ]));
               end;
            node2:=Items.AddChild(node1,'Methods');
            for c1:=0 to Methods.Count-1 do
               with Methods[c1] do
                  Items.AddChild(node2,Format('''%s'': %s (%d input arguments)',[
                     Name,
                     GetEnumName(TypeInfo(TatPascalTypeKind),ord(ResultDataType)),
                     ArgCount ]));
         end;
      FullCollapse;
      Items[0].Expand(false);
      Items[0].GetNextSibling.Expand(false);
      Items.EndUpDate;
      { general information }
      pnScriptInfo.Caption:=Format('Code size: %d simplified instructions',[CodeSize]);
   end;
   { show! }
   ShowModal;
end;

end.
